contrast {stats} | R Documentation

## Contrast Matrices

### Description

Return a matrix of contrasts.

### Usage

    contr.helmert(n, contrasts = TRUE)
    contr.poly(n, scores = 1:n, contrasts = TRUE)
    contr.sum(n, contrasts = TRUE)
    contr.treatment(n, base = 1, contrasts = TRUE)
    contr.SAS(n, contrasts = TRUE)

### Arguments

`n` | a vector of levels for a factor, or the number of levels.
`contrasts` | a logical indicating whether contrasts should be computed.
`scores` | the set of values over which orthogonal polynomials are to be computed.
`base` | an integer specifying which group is considered the baseline group. Ignored if `contrasts` is `FALSE`.

### Details

These functions are used for creating contrast matrices for use in fitting analysis of variance and regression models. The columns of the resulting matrices contain contrasts which can be used for coding a factor with `n` levels. The returned value contains the computed contrasts. If the argument `contrasts` is `FALSE` a square indicator matrix (the dummy coding) is returned except for `contr.poly` (which include the 0-degree, i.e. constant, polynomial when `contrasts = FALSE`).

`cont.helmert` returns Helmert contrasts, which contrast the second level with the first, the third with the average of the first two, and so on. `contr.poly` returns contrasts based on orthogonal polynomials. `contr.sum` uses ‘sum to zero contrasts’.

`contr.treatment` contrasts each level with the baseline level (specified by `base`): the baseline level is omitted. Note that this does not produce ‘contrasts’ as defined in the standard theory for linear models as they are not orthogonal to the intercept.

`contr.SAS` is a wrapper for `contr.treatment` that sets the base level to be the last level of the factor. The coefficients produced when using these contrasts should be equivalent to those produced by many (but not all) SAS procedures.

### Value

A matrix with `n` rows and `k` columns, with `k=n-1` if `contrasts` is `TRUE` and `k=n` if `contrasts` is `FALSE`.

### References

Chambers, J. M. and Hastie, T. J. (1992) Statistical models. Chapter 2 of Statistical Models in S eds J. M. Chambers and T. J. Hastie, Wadsworth & Brooks/Cole.

### See Also

`contrasts`, `C`, and `aov`, `glm`, `lm`.

### Examples

    (cH <- contr.helmert(4))
    apply(cH, 2,sum) # column sums are 0!
    crossprod(cH) # diagonal -- columns are orthogonal
    contr.helmert(4, contrasts = FALSE) # just the 4 x 4 identity matrix

    (cT <- contr.treatment(5))
    all(crossprod(cT) == diag(4)) # TRUE: even orthonormal

    (cP <- contr.SAS(5))
    all(crossprod(cP) == diag(4)) # TRUE: even orthonormal

    (cP <- contr.poly(3)) # Linear and Quadratic
    zapsmall(crossprod(cP), dig=15) # orthonormal up to fuzz

[Package stats version 2.3.1 Index]